searchData={"items":[{"type":"module","doc":"Documentation for `JediHelpers`.","title":"JediHelpers","ref":"JediHelpers.html"},{"type":"function","doc":"Converts an atom into a human-readable string by title-casing its segments.\n\nUseful for displaying labels or headings derived from atoms.","title":"JediHelpers.atom_to_readable_string/1","ref":"JediHelpers.html#atom_to_readable_string/1"},{"type":"function","doc":"iex> JediHelpers.atom_to_readable_string(:user_profile)\n    \"User Profile\"\n\n    iex> JediHelpers.atom_to_readable_string(:admin)\n    \"Admin\"","title":"Examples - JediHelpers.atom_to_readable_string/1","ref":"JediHelpers.html#atom_to_readable_string/1-examples"},{"type":"function","doc":"Formats a decimal or numeric input by:\n\n  - Converting it to a `Decimal`\n  - Rounding to 2 decimal places\n  - Converting to a string\n  - Adding thousands separators (e.g., `\"1,234.56\"`)\n\nReturns `nil` if the input is `nil`.","title":"JediHelpers.format_decimal/1","ref":"JediHelpers.html#format_decimal/1"},{"type":"function","doc":"iex> format_decimal(1234567.891)\n    \"1,234,567.89\"\n\n    iex> format_decimal(\"1000.1\")\n    \"1,000.10\"\n\n    iex> format_decimal(nil)\n    nil","title":"Examples - JediHelpers.format_decimal/1","ref":"JediHelpers.html#format_decimal/1-examples"},{"type":"function","doc":"Requires the `:decimal` and `:number` libraries.","title":"Requirements - JediHelpers.format_decimal/1","ref":"JediHelpers.html#format_decimal/1-requirements"},{"type":"function","doc":"Formats a given amount into a currency string using `Money`.","title":"JediHelpers.format_money/3","ref":"JediHelpers.html#format_money/3"},{"type":"function","doc":"- `amount`: A number representing the amount to format.\n  - `currency`: A string or atom representing the ISO 4217 currency code (e.g., `:php` for Philippine Peso).\n  - `opts` (optional): A keyword list of formatting options passed to `Money.to_string/2`.","title":"Parameters - JediHelpers.format_money/3","ref":"JediHelpers.html#format_money/3-parameters"},{"type":"function","doc":"- A formatted currency string on success.\n  - The error reason as a string on failure.\n  - `nil` if the `amount` is `nil`.","title":"Returns - JediHelpers.format_money/3","ref":"JediHelpers.html#format_money/3-returns"},{"type":"function","doc":"iex> format_money(1000, :php)\n    \"₱1,000.00\"\n\n    iex> format_money(nil, :php)\n    nil\n\n    iex> format_money(1234.56, :php, symbol: false)\n    \"1,234.56 PHP\"","title":"Examples - JediHelpers.format_money/3","ref":"JediHelpers.html#format_money/3-examples"},{"type":"function","doc":"The `opts` are forwarded to `Money.to_string/2`.  \nRefer to the [ex_money Money.to_string/2 documentation](https://hexdocs.pm/ex_money/Money.html#to_string/2) for the full list of supported options.","title":"Formatting Options - JediHelpers.format_money/3","ref":"JediHelpers.html#format_money/3-formatting-options"},{"type":"function","doc":"Formats a user's full name as `\"First Last\"`.\n\nReturns `nil` if the input is `nil`.","title":"JediHelpers.format_name/1","ref":"JediHelpers.html#format_name/1"},{"type":"function","doc":"iex> format_name(%{first_name: \"Luke\", last_name: \"Skywalker\"})\n    \"Luke Skywalker\"","title":"Examples - JediHelpers.format_name/1","ref":"JediHelpers.html#format_name/1-examples"},{"type":"function","doc":"Formats a user's name as `\"Last, First\"` if `:last_first` style is passed.","title":"JediHelpers.format_name/2","ref":"JediHelpers.html#format_name/2"},{"type":"function","doc":"iex> format_name(%{first_name: \"Luke\", last_name: \"Skywalker\"}, :last_first)\n    \"Skywalker, Luke\"","title":"Examples - JediHelpers.format_name/2","ref":"JediHelpers.html#format_name/2-examples"},{"type":"function","doc":"Formats a user's full name with email as `\"First Last - email@example.com\"`.","title":"JediHelpers.format_name_with_email/1","ref":"JediHelpers.html#format_name_with_email/1"},{"type":"function","doc":"iex> format_name_with_email(%{first_name: \"Leia\", last_name: \"Organa\", email: \"leia@alderaan.com\"})\n    \"Leia Organa - leia@alderaan.com\"","title":"Examples - JediHelpers.format_name_with_email/1","ref":"JediHelpers.html#format_name_with_email/1-examples"},{"type":"function","doc":"Returns the underscored (snake_case) name of a struct's module as a string.\n\nUseful for generating type identifiers from structs, especially in APIs or dynamic logic.","title":"JediHelpers.resource_type/1","ref":"JediHelpers.html#resource_type/1"},{"type":"function","doc":"iex> resource_type(%JediHelpers.BlogPost{})\n    \"blog_post\"","title":"Example - JediHelpers.resource_type/1","ref":"JediHelpers.html#resource_type/1-example"},{"type":"function","doc":"- `resource` (`struct`): Any Elixir struct.","title":"Parameters: - JediHelpers.resource_type/1","ref":"JediHelpers.html#resource_type/1-parameters"},{"type":"function","doc":"- `String.t()`: The snake_case name of the struct's module (last segment only).","title":"Returns: - JediHelpers.resource_type/1","ref":"JediHelpers.html#resource_type/1-returns"},{"type":"function","doc":"Extracts the path segment from a URI string.\n\nUseful for isolating the path portion of a full URL (e.g. `/users/123`).","title":"JediHelpers.uri_parse_path/1","ref":"JediHelpers.html#uri_parse_path/1"},{"type":"function","doc":"iex> uri_parse_path(\"https://example.com/users/123?ref=home\")\n    \"/users/123\"","title":"Example - JediHelpers.uri_parse_path/1","ref":"JediHelpers.html#uri_parse_path/1-example"},{"type":"function","doc":"- `uri` (`String.t()`): A URI string.","title":"Parameters: - JediHelpers.uri_parse_path/1","ref":"JediHelpers.html#uri_parse_path/1-parameters"},{"type":"function","doc":"- `String.t()` or `nil`: The path component of the URI, or `nil` if absent.","title":"Returns: - JediHelpers.uri_parse_path/1","ref":"JediHelpers.html#uri_parse_path/1-returns"},{"type":"module","doc":"","title":"JediHelpers.ChangesetHelpers","ref":"JediHelpers.ChangesetHelpers.html"},{"type":"function","doc":"Trims leading and trailing whitespaces from the specified fields in the changeset.\nThis ensures consistency and helps maintain uniqueness, especially for `citext` fields.\n\nYou can also specify a `max` length in the `opts` to validate that the field's length\nafter trimming does not exceed the specified value. If it exceeds, a validation error is added.","title":"JediHelpers.ChangesetHelpers.trim_whitespace/3","ref":"JediHelpers.ChangesetHelpers.html#trim_whitespace/3"},{"type":"function","doc":"changeset\n|> trim_whitespace(:username, max: 50)\n|> unique_constraint(:username)","title":"Example - JediHelpers.ChangesetHelpers.trim_whitespace/3","ref":"JediHelpers.ChangesetHelpers.html#trim_whitespace/3-example"},{"type":"function","doc":"- `changeset` (`Ecto.Changeset.t()`): The changeset containing the field to be processed.\n- `field` (`atom()` or `[atom()]`): The field(s) to trim.\n- `opts` (`keyword()`): Options for the function:\n- `:max` (`integer()`): The maximum allowed length after trimming. Adds a validation error if exceeded.","title":"Parameters: - JediHelpers.ChangesetHelpers.trim_whitespace/3","ref":"JediHelpers.ChangesetHelpers.html#trim_whitespace/3-parameters"},{"type":"function","doc":"- An updated `Ecto.Changeset.t()` with the trimmed field and potential validation error if the length exceeds `max`.","title":"Returns: - JediHelpers.ChangesetHelpers.trim_whitespace/3","ref":"JediHelpers.ChangesetHelpers.html#trim_whitespace/3-returns"},{"type":"module","doc":"","title":"JediHelpers.DateUtils","ref":"JediHelpers.DateUtils.html"},{"type":"function","doc":"Parses a variety of date formats into a `Date` struct.","title":"JediHelpers.DateUtils.to_date/1","ref":"JediHelpers.DateUtils.html#to_date/1"},{"type":"function","doc":"* `\"\"` or `\"0\"` – returns `nil`\n* A `Date` struct – returns the date itself\n* Excel serial date string (e.g. `\"40135\"`) – returns the corresponding `Date`\n* ISO-ish strings (e.g. `\"2023-1-5\"`, `\"2023-01-05\"`) – returns the parsed `Date`\n* Strings with leading/trailing whitespace are trimmed\n* Invalid or malformed strings return `nil`","title":"Supported inputs - JediHelpers.DateUtils.to_date/1","ref":"JediHelpers.DateUtils.html#to_date/1-supported-inputs"},{"type":"function","doc":"iex> to_date(\"40135\")\n~D[2009-11-18]\n\niex> to_date(\"2024-1-9\")\n~D[2024-01-09]\n\niex> to_date(\"\")\nnil\n\niex> to_date(%Date{year: 2020, month: 5, day: 10})\n~D[2020-05-10]\n\niex> to_date(\"not a date\")\nnil","title":"Examples - JediHelpers.DateUtils.to_date/1","ref":"JediHelpers.DateUtils.html#to_date/1-examples"},{"type":"module","doc":"Helper functions for form inputs and options.","title":"JediHelpers.FormHelpers","ref":"JediHelpers.FormHelpers.html"},{"type":"function","doc":"Generates `{label, id}` tuples for a list of maps or structs to be used in dropdowns.","title":"JediHelpers.FormHelpers.options_for/2","ref":"JediHelpers.FormHelpers.html#options_for/2"},{"type":"function","doc":"iex> users = [%{id: 1, name: \"Alice\"}, %{id: 2, name: \"Bob\"}]\n    iex> JediHelpers.FormHelpers.options_for(users, :name)\n    [{\"Alice\", 1}, {\"Bob\", 2}]\n\nRaises if an element is not a map or struct, or if the arguments are invalid.","title":"Examples - JediHelpers.FormHelpers.options_for/2","ref":"JediHelpers.FormHelpers.html#options_for/2-examples"},{"type":"extras","doc":"# JediHelpers\n\nA collection of general-purpose helpers for Elixir projects, designed to make your codebase cleaner and more reusable. Includes utilities for working with changesets and common functional patterns.","title":"JediHelpers","ref":"readme.html"},{"type":"extras","doc":"- `JediHelpers.ChangesetHelpers.trim_whitespace/2` – trims leading and trailing whitespace from string fields in Ecto changesets.\n- Other helper functions coming soon.","title":"Features - JediHelpers","ref":"readme.html#features"},{"type":"extras","doc":"Add `:jedi_helpers` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:jedi_helpers, \"~> 0.2.0\"}\n  ]\nend\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","title":"Installation - JediHelpers","ref":"readme.html#installation"},{"type":"extras","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\n## [0.2.0] - 2025-05-14","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"- `to_date/3` to parse dates with an optional fallback or custom parsing logic.\n\n## [0.1.2] - 2025-05-11","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"- `format_money/3` to format monetary amounts using `Money.to_string/2` with optional formatting options.\n\n## [0.1.1] - 2025-05-09","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"- `format_decimal/1` to format decimals with commas and 2 decimal places.\n- `format_name/1` and `format_name/2` for flexible user name formatting.\n- `format_name_with_email/1` for full name + email formatting.\n\n## [0.1.0] - 2025-05-06","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"- Initial release with Changeset Helpers,  FormHelpers, and other utility functions.","title":"Added - Changelog","ref":"changelog.html#added"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}